Subject: dd: misleading parsing of hex numbers

From: Stephan Bauroth <[email-masked]>
Date: Fri, 4 Nov 2016 12:19:40 +0100

Dear coreutils team :)

I encountered a buglike behaviour of dd when handling skip and count 
parameters that are encoded in hex and thus prefixed with 0x.

dd is not able to parse them, which is OK but would be great if it would 
be, but, worse, reads 0xf00 as 0. It does that silently. While an 
enduser will immediately notice this on count, since nothing is copied, 
behaviour for skip looks ok. (In fact, I noticed this only because I 
hexdumped the result after hours of debugging)

While it's OK that dd can't parse these numbers, maybe there should be a 
warning that 0x was found and interpreted as 0. Since a char like 'x' is 
invalid within a number that by definition has to be decimal, a warning 
should be fairly easy to implement.

Of course, the ability to parse hex numbers in these parameters would be 
awesome :)

regards and thanks for your continuing work,
Stephan Bauroth